' RemoveScript.VBS V1.09 (C) yoshioka.teruo@nifty.com 2006-07-25
' RemoveScript.VBS removes scripts from html files.
' Usage: Start RemoveScript.VBS htmlfiles...

Option Explicit
Dim wShell
Dim fso
Dim Path
Dim File
Dim FolderName
Dim FileName
Dim BaseName
Dim oPath
Dim sPath
Dim n,k
Dim tName

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

If WScript.Arguments.Count=0 Then
  MsgBox "Usage: Start ScRemove.VBS htmlfiles...",,WScript.ScriptName
  WScript.Quit
End If
For Each Path In WScript.Arguments
  Set File=fso.GetFile(Path)
  Path=File.Path
  FolderName=fso.GetParentFolderName(Path)
  FileName=File.Name
  BaseName=fso.GetBaseName(FileName)
  oPath=fso.BuildPath(FolderName,BaseName & ".suspect")
  sPath=fso.BuildPath(FolderName,BaseName & ".script")
  n=ScRemove(OpenTextFile(fso,Path),fso.CreateTextFile(oPath),fso.CreateTextFile(sPath))

  If n Then
    For k=1000 To 1999
      tName=BaseName & "." & Right(k ,3)
      Call Rename(File,tName)
      If Err=0 Then
        Exit For
      ElseIf Err<>58 Then
        MsgBox Err.Number & " : " & Err.Description,,WScript.ScriptName
        WScript.Quit
      End If
    Next
    If MsgBox(n & " Scripts Removed." & vbLf & FileName & " ---> " & tName & vbLf & "Browse the scripts ?",vbOkCancel+vbQuestion,WScript.ScriptName)=vbOK Then
      wShell.Run "Notepad.exe """ & sPath & """",,True
    End If
    Set File=fso.GetFile(oPath)
    Call Rename(File,FileName)
    If Err<>0  Then
      MsgBox Err.Number & ":" & Err.Description
      WScript.Quit
    End If
  Else
    fso.DeleteFile oPath
    fso.DeleteFile sPath
    MsgBox "No Scripts Removed." & vbLf & FileName,,WScript.ScriptName
  End If
  n=ScFind(OpenTextFile(fso,Path),fso.CreateTextFile(oPath))
  If n Then
    If MsgBox(n & " Suspicious Lines Found." & vbLf & FileName & vbLf & "Browse the lines ?",vbOkCancel+vbQuestion,WScript.ScriptName)=vbOK Then
      wShell.Run "Notepad.exe """ & oPath & """",,True
    End If
  Else
    MsgBox "Suspicious Strings Not Found." & vbLf & FileName,,WScript.ScriptName
    fso.DeleteFile oPath
  End If
Next
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Function ScRemove(StdIn,StdOut,StdErr)
Dim RightContent
Dim re
Dim Match
Dim Matches
Dim Scripts
Dim LeftContent
Dim n:n=0

Dim RightContent2
Dim re2
Dim Match2
Dim Matches2
Dim LeftContent2

If StdIn.AtEndOfStream Then Exit Function
RightContent=ReadAll(StdIn)
Scripts=Array()
LeftContent=Array()
Set re=New RegExp
re.IgnoreCase=True
re.Pattern="<SCRIPT[\s>][\s\S]*?</SCRIPT\s*>" & "|" & _
  "<NOSCRIPT[\s>][\s\S]*?</NOSCRIPT\s*>" & "|" & _
  "<APPLET[\s>][\s\S]*?</APPLET\s*>" & "|" & _
  "<IFRAME[\s>][\s\S]*?</IFRAME\s*>" & "|" & _
  "<INPUT\s[^>]*NAME\s*=\s*__VIEWSTATE\s*>" &  "|" & _
  "<LINK\s[^>]*>" &  "|" & _
  "<BASE\s[^>]*>" &  "|" & _
  "<!-- saved from url=[^>]* -->" &  "|" & _
  "<OBJECT\s[\s\S]*?</OBJECT\s*>"
Do
  Set Matches=re.Execute(RightContent)
  For Each Match In Matches
    n=n+1
    Push Scripts,Match.Value
    Push LeftContent,Left(RightContent,Match.FirstIndex)
    RightContent=Mid(RightContent,1+Match.FirstIndex+Match.Length)
    Exit For
  Next
Loop While Matches.Count>0
RightContent=Join(LeftContent,"") & RightContent
LeftContent=Array()
re.Pattern="<([^>'""]|'[^']*'|""([^""]|"""")*"")*>"
Set re2=New RegExp
re2.IgnoreCase=True
re2.Pattern="\sON[A-Z]{4,}\s*=\s*""(""""|[^""])*""" &  "|" & _
  "\sON[A-Z]{4,}\s*=\s*'[^']*'" &  "|" & _
  "\sON[A-Z]{4,}\s*=\s*[^\s>]*" &  "|" & _
  "\s(?:ACTION|HREF)\s*=\s*(?:JAVASCRIPT|VBSCRIPT):[^\s>]*" &  "|" & _
  "\s(?:ACTION|HREF)\s*=\s*""(?:JAVASCRIPT|VBSCRIPT):(?:""""|[^""])*""" &  "|" & _
  "\s(?:ACTION|HREF)\s*=\s*'(?:JAVASCRIPT|VBSCRIPT):[^']*'" &  "|" & _
  "\s(?:SRC|BACKGROUND)\s*=\s*HTTPS?:[^\s>]*" &  "|" & _
  "\s(?:SRC|BACKGROUND)\s*=\s*""HTTPS?:(?:""""|[^""])*""" &  "|" & _
  "\s(?:SRC|BACKGROUND)\s*=\s*'HTTPS?:[^']*'" &  "|" & _
  "\bExpression\([^""';]*"
Do
  Set Matches=re.Execute(RightContent)
  For Each Match In Matches
    RightContent2=Match.Value
    LeftContent2=Array()
    Do
      Set Matches2=re2.Execute(RightContent2)
      For Each Match2 In Matches2
        n=n+1
        Push Scripts,Match2.Value
        Push LeftContent2,Left(RightContent2,Match2.FirstIndex)
        RightContent2=Mid(RightContent2,1+Match2.FirstIndex+Match2.Length)
        Exit For
      Next
    Loop While Matches2.Count>0
    Push LeftContent,Left(RightContent,Match.FirstIndex) & Join(LeftContent2,"") & RightContent2
    RightContent=Mid(RightContent,1+Match.FirstIndex+Match.Length)
    Exit For
  Next
Loop While Matches.Count>0
StdOut.WriteLine Join(LeftContent,"") & RightContent
StdErr.WriteLine Join(Scripts,vbCrLf)
ScRemove=n
End Function

Function ScFind(StdIn,StdOut)
Dim Line
Dim re
Dim n

Set re=New RegExp
re.IgnoreCase=True
re.Pattern="CHARSET|SCRIPT|APPLET|IFRAME| ON[A-Z]{4,}|OBJECT|saved from url|Expression"
Do While Not StdIn.AtEndOfStream
  Line=StdIn.ReadLine()
  If re.Test(Line) Then
    n=n+1
    StdOut.WriteLine StdIn.line-1 & vbTab & Line
  End If
Loop
ScFind=n
End Function

Function ReadAll(TextFile)
Dim Blocks
Blocks=Array()
Do While Not TextFile.AtEndOfStream
  Push Blocks,Replace(TextFile.Read(4096),vbNullChar,"")
Loop
ReadAll=Replace(Join(Blocks,""),vbCR & vbCrLf,vbCrLf)
End Function

Function OpenTextFile(fso,Path)
Dim fUNICODE
Dim BOM
BOM=fso.OpenTextFile(Path).Read(2)
fUNICODE=BOM=Chr(&HFF)&Chr(&HFE) Or BOM=Chr(&HFE)&Chr(&HFF)
Set OpenTextFile=fso.OpenTextFile(Path,,,fUNICODE)
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
